#
# This file is part of Dist-Zilla-Plugin-Test-Compile
#
# This software is copyright (c) 2009 by Jérôme Quelin.
#
# This is free software; you can redistribute it and/or modify it under
# the same terms as the Perl 5 programming language system itself.
#
# This Build.PL for Dist-Zilla-Plugin-Test-Compile was generated by
# Dist::Zilla::Plugin::ModuleBuildTiny::Fallback 0.025
use strict;
use warnings;

my %configure_requires = (
    'ExtUtils::MakeMaker' => '0',
    'Module::Build::Tiny' => '0.034',
);

my %errors = map {
    eval "require $_; $_->VERSION($configure_requires{$_}); 1";
    $_ => $@,
} keys %configure_requires;

if (!grep { $_ } values %errors)
{
    # This section for Dist-Zilla-Plugin-Test-Compile was generated by Dist::Zilla::Plugin::ModuleBuildTiny 0.015.
    use strict;
    use warnings;

    use 5.008;
    # use Module::Build::Tiny 0.034;
    Module::Build::Tiny::Build_PL();
}
else
{
    if (not $ENV{PERL_MB_FALLBACK_SILENCE_WARNING})
    {
        warn <<'EOW'
*** WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING ***

If you're seeing this warning, your toolchain is really, really old* and you'll
almost certainly have problems installing CPAN modules from this century. But
never fear, dear user, for we have the technology to fix this!

If you're using CPAN.pm to install things, then you can upgrade it using:

    cpan CPAN

If you're using CPANPLUS to install things, then you can upgrade it using:

    cpanp CPANPLUS

If you're using cpanminus, you shouldn't be seeing this message in the first
place, so please file an issue on github.

This public service announcement was brought to you by the Perl Toolchain
Gang, the irc.perl.org #toolchain IRC channel, and the number 42.

----

* Alternatively, you are running this file manually, in which case you need
to learn to first fulfill all configure requires prerequisites listed in
META.yml or META.json -- or use a cpan client to install this distribution.

You can also silence this warning for future installations by setting the
PERL_MB_FALLBACK_SILENCE_WARNING environment variable, but please don't do
that until you fix your toolchain as described above.


Errors from configure prereqs:
EOW
        . do {
            require Data::Dumper; Data::Dumper->new([ \%errors ])->Indent(2)->Terse(1)->Sortkeys(1)->Dump;
        };

        sleep 10 if -t STDIN && (-t STDOUT || !(-f STDOUT || -c STDOUT));
    }


    # This section was automatically generated by Dist::Zilla::Plugin::ModuleBuild v6.010.
    use strict;
    use warnings;

    require Module::Build; Module::Build->VERSION(0.28);


    my %module_build_args = (
      "configure_requires" => {
        "ExtUtils::MakeMaker" => 0,
        "Module::Build::Tiny" => "0.034",
        "perl" => "5.006"
      },
      "dist_abstract" => "Common tests to check syntax of your modules, using only core modules",
      "dist_author" => [
        "J\x{e9}r\x{f4}me Quelin <jquelin\@gmail.com>",
        "Karen Etheridge <ether\@cpan.org>"
      ],
      "dist_name" => "Dist-Zilla-Plugin-Test-Compile",
      "dist_version" => "2.058",
      "license" => "perl",
      "module_name" => "Dist::Zilla::Plugin::Test::Compile",
      "recursive_test_files" => 1,
      "requires" => {
        "Data::Section" => "0.004",
        "Dist::Zilla" => "4.300039",
        "Dist::Zilla::Dist::Builder" => 0,
        "Dist::Zilla::File::InMemory" => 0,
        "Dist::Zilla::Role::FileFinderUser" => 0,
        "Dist::Zilla::Role::FileGatherer" => 0,
        "Dist::Zilla::Role::FileMunger" => 0,
        "Dist::Zilla::Role::PrereqSource" => 0,
        "Dist::Zilla::Role::TextTemplate" => 0,
        "Moose" => 0,
        "Moose::Util::TypeConstraints" => 0,
        "Path::Tiny" => 0,
        "Sub::Exporter::ForMethods" => 0,
        "namespace::autoclean" => 0,
        "perl" => "5.008",
        "strict" => 0,
        "warnings" => 0
      },
      "test_requires" => {
        "CPAN::Meta::Check" => "0.011",
        "CPAN::Meta::Requirements" => 0,
        "File::Spec" => 0,
        "File::pushd" => "1.004",
        "IO::Handle" => 0,
        "IPC::Open3" => 0,
        "Module::CoreList" => "2.77",
        "Module::Metadata" => 0,
        "Perl::PrereqScanner" => "1.016",
        "Test::DZil" => 0,
        "Test::Deep" => 0,
        "Test::MinimumVersion" => 0,
        "Test::More" => "0.96",
        "Test::Warnings" => "0.009",
        "if" => 0,
        "perl" => "5.008",
        "utf8" => 0,
        "version" => 0
      }
    );


    my %fallback_build_requires = (
      "CPAN::Meta::Check" => "0.011",
      "CPAN::Meta::Requirements" => 0,
      "File::Spec" => 0,
      "File::pushd" => "1.004",
      "IO::Handle" => 0,
      "IPC::Open3" => 0,
      "Module::CoreList" => "2.77",
      "Module::Metadata" => 0,
      "Perl::PrereqScanner" => "1.016",
      "Test::DZil" => 0,
      "Test::Deep" => 0,
      "Test::MinimumVersion" => 0,
      "Test::More" => "0.96",
      "Test::Warnings" => "0.009",
      "if" => 0,
      "perl" => "5.008",
      "utf8" => 0,
      "version" => 0
    );


    unless ( eval { Module::Build->VERSION(0.4004) } ) {
      delete $module_build_args{test_requires};
      $module_build_args{build_requires} = \%fallback_build_requires;
    }

    my $build = Module::Build->new(%module_build_args);


    $build->create_build_script;
}
